package com.galaxis.manatee.controller;

import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.context.request.WebRequest;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/4/3 3:20 下午
 */
@RestController
@Slf4j
public class ClawController {

    /**
     * 接口调用异常
     * @param exception 系统抛出异常
     * @param request   客户端请求
     * @return  返回结果
     */
    @ExceptionHandler(value = {Exception.class})
    public ResponseEntity vehicleNotFound(Exception exception, WebRequest request) {
        log.warn("异常");
        return new ResponseEntity(exception, HttpStatus.BAD_REQUEST);
    }
}
